package weaver.interfaces.aisin.cron;

import weaver.conn.RecordSet;
import weaver.general.BaseBean;
import weaver.general.TimeUtil;
import weaver.general.Util;
import weaver.interfaces.schedule.BaseCronJob;

import java.time.LocalDate;
import java.time.format.DateTimeFormatter;

/**
 * @Author liang.cheng
 * @Date 2024/11/26 2:44 PM
 * @Description: ATBP 考勤封账 每月1号主数据创建 uf_atbpkqfz
 * @Version 1.0
 */
public class KqCloseAccountCreateCrob extends BaseCronJob {

    @Override
    public void execute() {
        RecordSet rs = new RecordSet();
        BaseBean bb = new BaseBean();

        String kqMonth = getKqMonth();

        //1.数据是否存在
        rs.executeQuery("select count(1) as sums from uf_atbpkqfz where fzny = ?",kqMonth);
        rs.next();
        int sums = Util.getIntValue(rs.getString("sums"));

        String subcompanyid = bb.getPropValue("aisinsecond", "subcompanyid");
        String modeId = bb.getPropValue("aisinsecond", "fzModeid");
        String personId = bb.getPropValue("aisinsecond", "personId");
        String currentDate = TimeUtil.getCurrentDateString();
        String currentTime = TimeUtil.getOnlyCurrentTimeString();


        //2.若不存在
        if (sums == 0) {
            rs.executeUpdate("insert into uf_atbpkqfz(sjcjr,fzny,fb,kqjszt,modedatacreater,modedatacreatedate,modedatacreatetime,formmodeid) values(?,?,?,?,?,?,?,?)",
                    personId,kqMonth,subcompanyid,0,personId,currentDate,currentTime,modeId);
        }
    }


    private String getKqMonth() {
        LocalDate currentDate = LocalDate.now();
        LocalDate previousMonthDate = currentDate.minusMonths(1);
        DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyy-MM");
        return previousMonthDate.format(formatter);
    }
}
